include:
  - component: gitlab.com/components/secret-detection/secret-detection@~latest

vanilla:build-job:
  stage: build
  needs: []
  script:
    - echo "Hello, $GITLAB_USER_LOGIN!"

artifacts:build-job:
  stage: build
  needs: []
  before_script:
    - echo "First I go"
  script:
    - echo "Then me in the midle"
    - echo "An Artifact" > artifact-text.txt
  after_script:
    - echo "Then me at the end"
  artifacts:
    paths:
      - artifact-text.txt
    expire_in: 1 hour

vanilla:test:
  stage: test
  needs: ["vanilla:build-job"]
  script:
    - echo "This job tests something"

artifacts:test:
  stage: test
  needs: ["artifacts:build-job"]
  before_script:
    - pwd
    - ls -la
  script:
    - cat artifact-text.txt
  after_script:
    - echo "Artifact is tested!"

deploy-prod:
  stage: deploy
  needs: ["vanilla:build-job", "artifacts:test"]
  script:
    - echo "This job deploys something from the $CI_COMMIT_BRANCH branch."
  environment: production